> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nscale.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create project

> Creates a new project resource for the user's organization.



## OpenAPI

````yaml /openapi/identity-openapi.yaml post /api/v1/organizations/{organizationID}/projects
openapi: 3.0.3
info:
  title: Identity API
  description: >-
    The Identity API provides an OIDC compliant interface for use with all
    official

    and 3rd party services and proxies.  As its intended use is for multi-tenant
    cloud

    deployments, it acts as an aggregation layer for other 3rd party OIDC
    services,

    dispatching login requests to the required OIDC backend.  Token
    introspection forms

    the basis of role based access control across all APIs.  For security
    purposes,

    access tokens and refresh tokens are limited to a single session per client,
    thus

    if they are being consumed by a horizontally scalable platform care must be
    taken

    to ensure token rotation is handled atomically by a single process, and the
    tokens

    are distributed to each service instance synchronously.
  version: 1.11.0
servers:
  - url: https://identity.nks.europe-west4.nscale.com
security: []
paths:
  /api/v1/organizations/{organizationID}/projects:
    description: >-
      Implements project management services.  Projects are associated with

      user groups, and provide project-scoped role-based access control.

      Infrastructure provisioning, for example the Compute and Kubernetes
      services,

      occurs within a project.
    parameters:
      - $ref: '#/components/parameters/organizationIDParameter'
    post:
      tags:
        - Projects
      summary: Create project
      description: Creates a new project resource for the user's organization.
      requestBody:
        $ref: '#/components/requestBodies/createProjectRequest'
      responses:
        '202':
          $ref: '#/components/responses/projectResponse'
        '400':
          $ref: '#/components/responses/badRequestResponse'
        '401':
          $ref: '#/components/responses/unauthorizedResponse'
        '403':
          $ref: '#/components/responses/forbiddenResponse'
        '409':
          $ref: '#/components/responses/conflictResponse'
        '500':
          $ref: '#/components/responses/internalServerErrorResponse'
      security:
        - oauth2Authentication: []
components:
  parameters:
    organizationIDParameter:
      name: organizationID
      in: path
      description: An organization ID.
      required: true
      schema:
        type: string
  requestBodies:
    createProjectRequest:
      description: Project request parameters.
      required: true
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/projectWrite'
          example:
            metadata:
              name: my-project
            spec:
              groupIDs:
                - ddde69ef-bb52-4815-9e9e-aed856c6057f
  responses:
    projectResponse:
      description: A project.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/projectRead'
          example:
            metadata:
              id: a142f641-7fd6-4ab9-a875-344c7ebadc53
              name: my-project
              organizationId: d4600d6e-e965-4b44-a808-84fb2fa36702
              creationTime: '2024-05-31T14:11:00Z'
              provisioningStatus: provisioned
              healthStatus: healthy
            spec:
              groupIDs:
                - ef509cd1-c7e6-42f8-aae7-a01164dc60dc
    badRequestResponse:
      description: |-
        Request body failed schema validation, or the request does not contain
        all the required fields.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/error'
          example:
            error: invalid_request
            error_description: request body invalid
    unauthorizedResponse:
      description: Authentication failed or the access token has expired.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/error'
          example:
            error: access_denied
            error_description: authentication failed
    forbiddenResponse:
      description: >-
        Request was denied by authorization, this may be caused by the
        authorization

        token not having the required scope for an API, or the user doesn't have
        the

        necessary privileges on the provider platform.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/error'
          example:
            error: forbidden
            error_description: user credentials do not have the required privileges
    conflictResponse:
      description: >-
        Resource conflicts with another, usually this means they have the same
        name.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/error'
          example:
            error: conflict
            error_description: a resource with the same name already exists
    internalServerErrorResponse:
      description: >-
        An unexpected or unhandled error occurred. This may be a transient error
        and

        may succeed on a retry.  If this isn't the case, please report it as an
        issue.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/error'
          example:
            error: server_error
            error_description: failed to token claim
  schemas:
    projectWrite:
      description: A project when created or updated.
      type: object
      required:
        - metadata
        - spec
      properties:
        metadata:
          $ref: '#/components/schemas/resourceMetadata'
        spec:
          $ref: '#/components/schemas/projectSpec'
    projectRead:
      description: A project when read.
      type: object
      required:
        - metadata
        - spec
      properties:
        metadata:
          $ref: '#/components/schemas/organizationScopedResourceReadMetadata'
        spec:
          $ref: '#/components/schemas/projectSpec'
    error:
      description: Generic error message, compatible with oauth2.
      type: object
      required:
        - error
        - error_description
      properties:
        error:
          description: >-
            A terse error string expanding on the HTTP error code. Errors are
            based on the OAuth 2.02 specification, but are expanded with
            proprietary status codes for APIs other than those specified by
            OAuth 2.02.
          type: string
          enum:
            - invalid_request
            - server_error
            - access_denied
            - not_found
            - conflict
            - method_not_allowed
            - unsupported_media_type
            - request_entity_too_large
            - forbidden
        error_description:
          description: Verbose message describing the error.
          type: string
    resourceMetadata:
      description: Metadata required for all API resource reads and writes.
      required:
        - name
      properties:
        name:
          $ref: '#/components/schemas/kubernetesLabelValue'
        description:
          description: >-
            The resource description, this optionally augments the name with
            more context.
          type: string
        tags:
          $ref: '#/components/schemas/tagList'
    projectSpec:
      description: A project.
      type: object
      required:
        - groupIDs
      properties:
        groupIDs:
          $ref: '#/components/schemas/groupIDs'
    organizationScopedResourceReadMetadata:
      description: Metadata required by organization scoped resource reads.
      allOf:
        - $ref: '#/components/schemas/resourceReadMetadata'
        - type: object
          required:
            - organizationId
          properties:
            organizationId:
              description: The organization identifier the resource belongs to.
              type: string
    kubernetesLabelValue:
      description: >-
        A valid Kubernetes label value, typically used for resource names that
        can be

        indexed in the database.
      type: string
      pattern: ^[0-9A-Za-z](?:[0-9A-Za-z-_.]{0,61}[0-9A-Za-z])?$
    tagList:
      description: A list of tags.
      type: array
      items:
        $ref: '#/components/schemas/tag'
    groupIDs:
      description: A list of group IDs.
      type: array
      items:
        description: A group ID.
        type: string
    resourceReadMetadata:
      description: Metadata required by all resource reads.
      allOf:
        - $ref: '#/components/schemas/staticResourceMetadata'
        - type: object
          required:
            - provisioningStatus
            - healthStatus
          properties:
            deletionTime:
              description: The time the resource was deleted.
              type: string
              format: date-time
            provisioningStatus:
              $ref: '#/components/schemas/resourceProvisioningStatus'
            healthStatus:
              $ref: '#/components/schemas/resourceHealthStatus'
    tag:
      description: >-
        A tag mapping arbitrary names to values.  These have no special meaning

        for any component are are intended for use by end users to add
        additional

        context to a resource, for example to categorize it.
      type: object
      required:
        - name
        - value
      properties:
        name:
          description: A unique tag name.
          type: string
        value:
          description: The value of the tag.
          type: string
    staticResourceMetadata:
      description: |
        This metadata is for resources that just exist, and don't require
        any provisioning and health status, but benefit from a standardized
        metadata format.
      type: object
      allOf:
        - $ref: '#/components/schemas/resourceMetadata'
        - type: object
          required:
            - id
            - creationTime
          properties:
            id:
              description: The unique resource ID.
              type: string
            creationTime:
              description: The time the resource was created.
              type: string
              format: date-time
            createdBy:
              description: The user who created the resource.
              type: string
            modifiedTime:
              description: The time a resource was updated.
              type: string
              format: date-time
            modifiedBy:
              description: The user who updated the resource.
              type: string
    resourceProvisioningStatus:
      description: The provisioning state of a resource.
      type: string
      enum:
        - unknown
        - provisioning
        - provisioned
        - deprovisioning
        - error
    resourceHealthStatus:
      description: The health state of a resource.
      type: string
      enum:
        - unknown
        - healthy
        - degraded
        - error
  securitySchemes:
    oauth2Authentication:
      description: Operation requires OAuth 2.0 bearer token authentication.
      type: oauth2
      flows:
        authorizationCode:
          authorizationUrl: https://identity.nks.europe-west4.nscale.com/oauth2/v2/authorization
          tokenUrl: https://identity.nks.europe-west4.nscale.com/oauth2/v2/token
          scopes: {}

````